/* ConnectionMenu.c generated by valac 0.44.11, the Vala compiler
 * generated from ConnectionMenu.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>

#define TYPE_CONNECTION_MENU (connection_menu_get_type ())
#define CONNECTION_MENU(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONNECTION_MENU, ConnectionMenu))
#define CONNECTION_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONNECTION_MENU, ConnectionMenuClass))
#define IS_CONNECTION_MENU(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONNECTION_MENU))
#define IS_CONNECTION_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONNECTION_MENU))
#define CONNECTION_MENU_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONNECTION_MENU, ConnectionMenuClass))

typedef struct _ConnectionMenu ConnectionMenu;
typedef struct _ConnectionMenuClass ConnectionMenuClass;
typedef struct _ConnectionMenuPrivate ConnectionMenuPrivate;

#define TYPE_DRAW_AREA (draw_area_get_type ())
#define DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DRAW_AREA, DrawArea))
#define DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DRAW_AREA, DrawAreaClass))
#define IS_DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DRAW_AREA))
#define IS_DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DRAW_AREA))
#define DRAW_AREA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DRAW_AREA, DrawAreaClass))

typedef struct _DrawArea DrawArea;
typedef struct _DrawAreaClass DrawAreaClass;
enum  {
	CONNECTION_MENU_0_PROPERTY,
	CONNECTION_MENU_NUM_PROPERTIES
};
static GParamSpec* connection_menu_properties[CONNECTION_MENU_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_CONNECTION (connection_get_type ())
#define CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONNECTION, Connection))
#define CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONNECTION, ConnectionClass))
#define IS_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONNECTION))
#define IS_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONNECTION))
#define CONNECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONNECTION, ConnectionClass))

typedef struct _Connection Connection;
typedef struct _ConnectionClass ConnectionClass;

#define TYPE_CANVAS_TEXT (canvas_text_get_type ())
#define CANVAS_TEXT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CANVAS_TEXT, CanvasText))
#define CANVAS_TEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CANVAS_TEXT, CanvasTextClass))
#define IS_CANVAS_TEXT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CANVAS_TEXT))
#define IS_CANVAS_TEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CANVAS_TEXT))
#define CANVAS_TEXT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CANVAS_TEXT, CanvasTextClass))

typedef struct _CanvasText CanvasText;
typedef struct _CanvasTextClass CanvasTextClass;
typedef enum  {
	CONN_MODE_NONE = 0,
	CONN_MODE_LINKING,
	CONN_MODE_CONNECTING,
	CONN_MODE_SELECTED,
	CONN_MODE_ADJUSTING,
	CONN_MODE_EDITABLE
} ConnMode;

#define TYPE_CONN_MODE (conn_mode_get_type ())

struct _ConnectionMenu {
	GtkMenu parent_instance;
	ConnectionMenuPrivate * priv;
};

struct _ConnectionMenuClass {
	GtkMenuClass parent_class;
};

struct _ConnectionMenuPrivate {
	DrawArea* _da;
	GtkMenuItem* _delete;
	GtkMenuItem* _edit;
	GtkMenuItem* _note;
	GtkMenuItem* _selstart;
	GtkMenuItem* _selend;
	GtkMenuItem* _selnext;
	GtkMenuItem* _selprev;
};

static gint ConnectionMenu_private_offset;
static gpointer connection_menu_parent_class = NULL;

GType connection_menu_get_type (void) G_GNUC_CONST;
GType draw_area_get_type (void) G_GNUC_CONST;
ConnectionMenu* connection_menu_new (DrawArea* da,
                                     GtkAccelGroup* accel_group);
ConnectionMenu* connection_menu_construct (GType object_type,
                                           DrawArea* da,
                                           GtkAccelGroup* accel_group);
static void connection_menu_delete_connection (ConnectionMenu* self);
static void _connection_menu_delete_connection_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                gpointer self);
void utils_add_accel_label (GtkMenuItem* item,
                            guint key,
                            GdkModifierType mods);
static void connection_menu_edit_title (ConnectionMenu* self);
static void _connection_menu_edit_title_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                         gpointer self);
static void connection_menu_change_note (ConnectionMenu* self);
static void _connection_menu_change_note_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                          gpointer self);
static void connection_menu_select_start_node (ConnectionMenu* self);
static void _connection_menu_select_start_node_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                gpointer self);
static void connection_menu_select_end_node (ConnectionMenu* self);
static void _connection_menu_select_end_node_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                              gpointer self);
static void connection_menu_select_next_connection (ConnectionMenu* self);
static void _connection_menu_select_next_connection_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                     gpointer self);
static void connection_menu_select_prev_connection (ConnectionMenu* self);
static void _connection_menu_select_prev_connection_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                     gpointer self);
static void connection_menu_on_popup (ConnectionMenu* self);
static void _connection_menu_on_popup_gtk_widget_show (GtkWidget* _sender,
                                                gpointer self);
static gboolean connection_menu_connection_has_note (ConnectionMenu* self);
GType connection_get_type (void) G_GNUC_CONST;
Connection* draw_area_get_current_connection (DrawArea* self);
const gchar* connection_get_note (Connection* self);
void draw_area_delete_connection (DrawArea* self);
GType canvas_text_get_type (void) G_GNUC_CONST;
CanvasText* connection_get_title (Connection* self);
void connection_change_title (Connection* self,
                              DrawArea* da,
                              const gchar* title,
                              gboolean allow_empty);
GType conn_mode_get_type (void) G_GNUC_CONST;
void connection_set_mode (Connection* self,
                          ConnMode value);
void draw_area_change_current_connection_note (DrawArea* self,
                                               const gchar* note);
void draw_area_select_connection_node (DrawArea* self,
                                       gboolean start);
void draw_area_select_connection (DrawArea* self,
                                  gint dir);
static void connection_menu_finalize (GObject * obj);

static inline gpointer
connection_menu_get_instance_private (ConnectionMenu* self)
{
	return G_STRUCT_MEMBER_P (self, ConnectionMenu_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
_connection_menu_delete_connection_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                           gpointer self)
{
	connection_menu_delete_connection ((ConnectionMenu*) self);
}

static void
_connection_menu_edit_title_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                    gpointer self)
{
	connection_menu_edit_title ((ConnectionMenu*) self);
}

static void
_connection_menu_change_note_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                     gpointer self)
{
	connection_menu_change_note ((ConnectionMenu*) self);
}

static void
_connection_menu_select_start_node_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                           gpointer self)
{
	connection_menu_select_start_node ((ConnectionMenu*) self);
}

static void
_connection_menu_select_end_node_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                         gpointer self)
{
	connection_menu_select_end_node ((ConnectionMenu*) self);
}

static void
_connection_menu_select_next_connection_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                gpointer self)
{
	connection_menu_select_next_connection ((ConnectionMenu*) self);
}

static void
_connection_menu_select_prev_connection_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                gpointer self)
{
	connection_menu_select_prev_connection ((ConnectionMenu*) self);
}

static void
_connection_menu_on_popup_gtk_widget_show (GtkWidget* _sender,
                                           gpointer self)
{
	connection_menu_on_popup ((ConnectionMenu*) self);
}

ConnectionMenu*
connection_menu_construct (GType object_type,
                           DrawArea* da,
                           GtkAccelGroup* accel_group)
{
	ConnectionMenu * self = NULL;
	DrawArea* _tmp0_;
	GtkMenuItem* _tmp1_;
	GtkMenuItem* _tmp2_;
	GtkMenuItem* _tmp3_;
	GtkMenuItem* _tmp4_;
	GtkMenuItem* _tmp5_;
	GtkMenuItem* _tmp6_;
	GtkMenuItem* _tmp7_;
	GtkMenuItem* _tmp8_;
	GtkMenuItem* selnode = NULL;
	GtkMenuItem* _tmp9_;
	GtkMenu* selmenu = NULL;
	GtkMenu* _tmp10_;
	GtkMenuItem* _tmp11_;
	GtkMenuItem* _tmp12_;
	GtkMenuItem* _tmp13_;
	GtkMenuItem* _tmp14_;
	GtkMenuItem* _tmp15_;
	GtkMenuItem* _tmp16_;
	GtkMenuItem* _tmp17_;
	GtkMenuItem* _tmp18_;
	GtkMenuItem* _tmp19_;
	GtkMenuItem* _tmp20_;
	GtkMenuItem* _tmp21_;
	GtkMenuItem* _tmp22_;
	GtkMenuItem* _tmp23_;
	GtkSeparatorMenuItem* _tmp24_;
	GtkSeparatorMenuItem* _tmp25_;
	GtkMenuItem* _tmp26_;
	GtkMenuItem* _tmp27_;
	GtkSeparatorMenuItem* _tmp28_;
	GtkSeparatorMenuItem* _tmp29_;
	GtkMenuItem* _tmp30_;
	GtkMenuItem* _tmp31_;
	GtkSeparatorMenuItem* _tmp32_;
	GtkSeparatorMenuItem* _tmp33_;
	GtkMenuItem* _tmp34_;
	GtkMenuItem* _tmp35_;
	g_return_val_if_fail (da != NULL, NULL);
	g_return_val_if_fail (accel_group != NULL, NULL);
	self = (ConnectionMenu*) g_object_new (object_type, NULL);
	_tmp0_ = _g_object_ref0 (da);
	_g_object_unref0 (self->priv->_da);
	self->priv->_da = _tmp0_;
	_tmp1_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Delete"));
	g_object_ref_sink (_tmp1_);
	_g_object_unref0 (self->priv->_delete);
	self->priv->_delete = _tmp1_;
	_tmp2_ = self->priv->_delete;
	g_signal_connect_object (_tmp2_, "activate", (GCallback) _connection_menu_delete_connection_gtk_menu_item_activate, self, 0);
	_tmp3_ = self->priv->_delete;
	utils_add_accel_label (_tmp3_, (guint) 65535, 0);
	_tmp4_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Edit…"));
	g_object_ref_sink (_tmp4_);
	_g_object_unref0 (self->priv->_edit);
	self->priv->_edit = _tmp4_;
	_tmp5_ = self->priv->_edit;
	g_signal_connect_object (_tmp5_, "activate", (GCallback) _connection_menu_edit_title_gtk_menu_item_activate, self, 0);
	_tmp6_ = self->priv->_edit;
	utils_add_accel_label (_tmp6_, (guint) 'e', 0);
	_tmp7_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Add Note"));
	g_object_ref_sink (_tmp7_);
	_g_object_unref0 (self->priv->_note);
	self->priv->_note = _tmp7_;
	_tmp8_ = self->priv->_note;
	g_signal_connect_object (_tmp8_, "activate", (GCallback) _connection_menu_change_note_gtk_menu_item_activate, self, 0);
	_tmp9_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Select"));
	g_object_ref_sink (_tmp9_);
	selnode = _tmp9_;
	_tmp10_ = (GtkMenu*) gtk_menu_new ();
	g_object_ref_sink (_tmp10_);
	selmenu = _tmp10_;
	gtk_menu_item_set_submenu (selnode, selmenu);
	_tmp11_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Start Node"));
	g_object_ref_sink (_tmp11_);
	_g_object_unref0 (self->priv->_selstart);
	self->priv->_selstart = _tmp11_;
	_tmp12_ = self->priv->_selstart;
	g_signal_connect_object (_tmp12_, "activate", (GCallback) _connection_menu_select_start_node_gtk_menu_item_activate, self, 0);
	_tmp13_ = self->priv->_selstart;
	utils_add_accel_label (_tmp13_, (guint) 'f', 0);
	_tmp14_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("End Node"));
	g_object_ref_sink (_tmp14_);
	_g_object_unref0 (self->priv->_selend);
	self->priv->_selend = _tmp14_;
	_tmp15_ = self->priv->_selend;
	g_signal_connect_object (_tmp15_, "activate", (GCallback) _connection_menu_select_end_node_gtk_menu_item_activate, self, 0);
	_tmp16_ = self->priv->_selend;
	utils_add_accel_label (_tmp16_, (guint) 't', 0);
	_tmp17_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Next Connection"));
	g_object_ref_sink (_tmp17_);
	_g_object_unref0 (self->priv->_selnext);
	self->priv->_selnext = _tmp17_;
	_tmp18_ = self->priv->_selnext;
	g_signal_connect_object (_tmp18_, "activate", (GCallback) _connection_menu_select_next_connection_gtk_menu_item_activate, self, 0);
	_tmp19_ = self->priv->_selnext;
	utils_add_accel_label (_tmp19_, (guint) 65363, 0);
	_tmp20_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Previous Connection"));
	g_object_ref_sink (_tmp20_);
	_g_object_unref0 (self->priv->_selprev);
	self->priv->_selprev = _tmp20_;
	_tmp21_ = self->priv->_selprev;
	g_signal_connect_object (_tmp21_, "activate", (GCallback) _connection_menu_select_prev_connection_gtk_menu_item_activate, self, 0);
	_tmp22_ = self->priv->_selprev;
	utils_add_accel_label (_tmp22_, (guint) 65361, 0);
	_tmp23_ = self->priv->_delete;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp23_);
	_tmp24_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
	g_object_ref_sink (_tmp24_);
	_tmp25_ = _tmp24_;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp25_);
	_g_object_unref0 (_tmp25_);
	_tmp26_ = self->priv->_edit;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp26_);
	_tmp27_ = self->priv->_note;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp27_);
	_tmp28_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
	g_object_ref_sink (_tmp28_);
	_tmp29_ = _tmp28_;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp29_);
	_g_object_unref0 (_tmp29_);
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) selnode);
	_tmp30_ = self->priv->_selstart;
	gtk_container_add ((GtkContainer*) selmenu, (GtkWidget*) _tmp30_);
	_tmp31_ = self->priv->_selend;
	gtk_container_add ((GtkContainer*) selmenu, (GtkWidget*) _tmp31_);
	_tmp32_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
	g_object_ref_sink (_tmp32_);
	_tmp33_ = _tmp32_;
	gtk_container_add ((GtkContainer*) selmenu, (GtkWidget*) _tmp33_);
	_g_object_unref0 (_tmp33_);
	_tmp34_ = self->priv->_selnext;
	gtk_container_add ((GtkContainer*) selmenu, (GtkWidget*) _tmp34_);
	_tmp35_ = self->priv->_selprev;
	gtk_container_add ((GtkContainer*) selmenu, (GtkWidget*) _tmp35_);
	gtk_widget_show_all ((GtkWidget*) self);
	g_signal_connect_object ((GtkWidget*) self, "show", (GCallback) _connection_menu_on_popup_gtk_widget_show, self, 0);
	_g_object_unref0 (selmenu);
	_g_object_unref0 (selnode);
	return self;
}

ConnectionMenu*
connection_menu_new (DrawArea* da,
                     GtkAccelGroup* accel_group)
{
	return connection_menu_construct (TYPE_CONNECTION_MENU, da, accel_group);
}

static gboolean
connection_menu_connection_has_note (ConnectionMenu* self)
{
	Connection* current = NULL;
	DrawArea* _tmp0_;
	Connection* _tmp1_;
	gboolean _tmp2_ = FALSE;
	Connection* _tmp3_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_da;
	_tmp1_ = draw_area_get_current_connection (_tmp0_);
	current = _tmp1_;
	_tmp3_ = current;
	if (_tmp3_ != NULL) {
		Connection* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		_tmp4_ = current;
		_tmp5_ = connection_get_note (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp2_ = g_strcmp0 (_tmp6_, "") != 0;
	} else {
		_tmp2_ = FALSE;
	}
	result = _tmp2_;
	_g_object_unref0 (current);
	return result;
}

static void
connection_menu_on_popup (ConnectionMenu* self)
{
	const gchar* _tmp0_ = NULL;
	GtkMenuItem* _tmp1_;
	g_return_if_fail (self != NULL);
	if (connection_menu_connection_has_note (self)) {
		_tmp0_ = _ ("Remove Note");
	} else {
		_tmp0_ = _ ("Add Note");
	}
	_tmp1_ = self->priv->_note;
	gtk_menu_item_set_label (_tmp1_, _tmp0_);
}

static void
connection_menu_delete_connection (ConnectionMenu* self)
{
	DrawArea* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_da;
	draw_area_delete_connection (_tmp0_);
}

static void
connection_menu_edit_title (ConnectionMenu* self)
{
	Connection* conn = NULL;
	DrawArea* _tmp0_;
	Connection* _tmp1_;
	Connection* _tmp2_;
	CanvasText* _tmp3_;
	CanvasText* _tmp4_;
	Connection* _tmp7_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_da;
	_tmp1_ = draw_area_get_current_connection (_tmp0_);
	conn = _tmp1_;
	_tmp2_ = conn;
	_tmp3_ = connection_get_title (_tmp2_);
	_tmp4_ = _tmp3_;
	if (_tmp4_ == NULL) {
		Connection* _tmp5_;
		DrawArea* _tmp6_;
		_tmp5_ = conn;
		_tmp6_ = self->priv->_da;
		connection_change_title (_tmp5_, _tmp6_, "", TRUE);
	}
	_tmp7_ = conn;
	connection_set_mode (_tmp7_, CONN_MODE_EDITABLE);
	_g_object_unref0 (conn);
}

static void
connection_menu_change_note (ConnectionMenu* self)
{
	DrawArea* _tmp2_;
	DrawArea* _tmp3_;
	g_return_if_fail (self != NULL);
	if (connection_menu_connection_has_note (self)) {
		DrawArea* _tmp0_;
		_tmp0_ = self->priv->_da;
		draw_area_change_current_connection_note (_tmp0_, "");
	} else {
		DrawArea* _tmp1_;
		_tmp1_ = self->priv->_da;
		g_signal_emit_by_name (_tmp1_, "show-properties", "current", TRUE);
	}
	_tmp2_ = self->priv->_da;
	_tmp3_ = self->priv->_da;
	g_signal_emit_by_name (_tmp2_, "current-changed", _tmp3_);
}

static void
connection_menu_select_start_node (ConnectionMenu* self)
{
	DrawArea* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_da;
	draw_area_select_connection_node (_tmp0_, TRUE);
}

static void
connection_menu_select_end_node (ConnectionMenu* self)
{
	DrawArea* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_da;
	draw_area_select_connection_node (_tmp0_, FALSE);
}

static void
connection_menu_select_next_connection (ConnectionMenu* self)
{
	DrawArea* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_da;
	draw_area_select_connection (_tmp0_, 1);
}

static void
connection_menu_select_prev_connection (ConnectionMenu* self)
{
	DrawArea* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_da;
	draw_area_select_connection (_tmp0_, -1);
}

static void
connection_menu_class_init (ConnectionMenuClass * klass,
                            gpointer klass_data)
{
	connection_menu_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &ConnectionMenu_private_offset);
	G_OBJECT_CLASS (klass)->finalize = connection_menu_finalize;
}

static void
connection_menu_instance_init (ConnectionMenu * self,
                               gpointer klass)
{
	self->priv = connection_menu_get_instance_private (self);
}

static void
connection_menu_finalize (GObject * obj)
{
	ConnectionMenu * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CONNECTION_MENU, ConnectionMenu);
	_g_object_unref0 (self->priv->_da);
	_g_object_unref0 (self->priv->_delete);
	_g_object_unref0 (self->priv->_edit);
	_g_object_unref0 (self->priv->_note);
	_g_object_unref0 (self->priv->_selstart);
	_g_object_unref0 (self->priv->_selend);
	_g_object_unref0 (self->priv->_selnext);
	_g_object_unref0 (self->priv->_selprev);
	G_OBJECT_CLASS (connection_menu_parent_class)->finalize (obj);
}

GType
connection_menu_get_type (void)
{
	static volatile gsize connection_menu_type_id__volatile = 0;
	if (g_once_init_enter (&connection_menu_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ConnectionMenuClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) connection_menu_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ConnectionMenu), 0, (GInstanceInitFunc) connection_menu_instance_init, NULL };
		GType connection_menu_type_id;
		connection_menu_type_id = g_type_register_static (gtk_menu_get_type (), "ConnectionMenu", &g_define_type_info, 0);
		ConnectionMenu_private_offset = g_type_add_instance_private (connection_menu_type_id, sizeof (ConnectionMenuPrivate));
		g_once_init_leave (&connection_menu_type_id__volatile, connection_menu_type_id);
	}
	return connection_menu_type_id__volatile;
}

