/* NodeBorder.c generated by valac 0.44.11, the Vala compiler
 * generated from NodeBorder.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <cairo.h>
#include <float.h>
#include <math.h>

#define TYPE_NODE_BORDER (node_border_get_type ())
#define NODE_BORDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NODE_BORDER, NodeBorder))
#define IS_NODE_BORDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NODE_BORDER))
#define NODE_BORDER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_NODE_BORDER, NodeBorderIface))

typedef struct _NodeBorder NodeBorder;
typedef struct _NodeBorderIface NodeBorderIface;
typedef enum  {
	NODE_SIDE_LEFT = 1,
	NODE_SIDE_TOP = 2,
	NODE_SIDE_RIGHT = 4,
	NODE_SIDE_BOTTOM = 8
} NodeSide;

#define TYPE_NODE_SIDE (node_side_get_type ())

struct _NodeBorderIface {
	GTypeInterface parent_iface;
	gchar* (*name) (NodeBorder* self);
	gchar* (*display_name) (NodeBorder* self);
	gchar* (*icon_name) (NodeBorder* self);
	gboolean (*is_fillable) (NodeBorder* self);
	void (*draw_border) (NodeBorder* self, cairo_t* ctx, gdouble x, gdouble y, gdouble w, gdouble h, NodeSide s);
	void (*draw_fill) (NodeBorder* self, cairo_t* ctx, gdouble x, gdouble y, gdouble w, gdouble h, NodeSide s);
};

GType node_side_get_type (void) G_GNUC_CONST;
GType node_border_get_type (void) G_GNUC_CONST;
gchar* node_border_name (NodeBorder* self);
gchar* node_border_display_name (NodeBorder* self);
gchar* node_border_icon_name (NodeBorder* self);
gboolean node_border_is_fillable (NodeBorder* self);
void node_border_draw_border (NodeBorder* self,
                              cairo_t* ctx,
                              gdouble x,
                              gdouble y,
                              gdouble w,
                              gdouble h,
                              NodeSide s);
void node_border_draw_fill (NodeBorder* self,
                            cairo_t* ctx,
                            gdouble x,
                            gdouble y,
                            gdouble w,
                            gdouble h,
                            NodeSide s);

gchar*
node_border_name (NodeBorder* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return NODE_BORDER_GET_INTERFACE (self)->name (self);
}

gchar*
node_border_display_name (NodeBorder* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return NODE_BORDER_GET_INTERFACE (self)->display_name (self);
}

gchar*
node_border_icon_name (NodeBorder* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return NODE_BORDER_GET_INTERFACE (self)->icon_name (self);
}

gboolean
node_border_is_fillable (NodeBorder* self)
{
	g_return_val_if_fail (self != NULL, FALSE);
	return NODE_BORDER_GET_INTERFACE (self)->is_fillable (self);
}

void
node_border_draw_border (NodeBorder* self,
                         cairo_t* ctx,
                         gdouble x,
                         gdouble y,
                         gdouble w,
                         gdouble h,
                         NodeSide s)
{
	g_return_if_fail (self != NULL);
	NODE_BORDER_GET_INTERFACE (self)->draw_border (self, ctx, x, y, w, h, s);
}

void
node_border_draw_fill (NodeBorder* self,
                       cairo_t* ctx,
                       gdouble x,
                       gdouble y,
                       gdouble w,
                       gdouble h,
                       NodeSide s)
{
	g_return_if_fail (self != NULL);
	NODE_BORDER_GET_INTERFACE (self)->draw_fill (self, ctx, x, y, w, h, s);
}

static void
node_border_default_init (NodeBorderIface * iface,
                          gpointer iface_data)
{
}

GType
node_border_get_type (void)
{
	static volatile gsize node_border_type_id__volatile = 0;
	if (g_once_init_enter (&node_border_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NodeBorderIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) node_border_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType node_border_type_id;
		node_border_type_id = g_type_register_static (G_TYPE_INTERFACE, "NodeBorder", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (node_border_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&node_border_type_id__volatile, node_border_type_id);
	}
	return node_border_type_id__volatile;
}

