/* ExportPDF.c generated by valac 0.44.11, the Vala compiler
 * generated from ExportPDF.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <float.h>
#include <math.h>
#include <cairo-pdf.h>
#include <cairo.h>

#define TYPE_EXPORT_PDF (export_pdf_get_type ())
#define EXPORT_PDF(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EXPORT_PDF, ExportPDF))
#define EXPORT_PDF_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EXPORT_PDF, ExportPDFClass))
#define IS_EXPORT_PDF(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EXPORT_PDF))
#define IS_EXPORT_PDF_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EXPORT_PDF))
#define EXPORT_PDF_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EXPORT_PDF, ExportPDFClass))

typedef struct _ExportPDF ExportPDF;
typedef struct _ExportPDFClass ExportPDFClass;
typedef struct _ExportPDFPrivate ExportPDFPrivate;
enum  {
	EXPORT_PDF_0_PROPERTY,
	EXPORT_PDF_NUM_PROPERTIES
};
static GParamSpec* export_pdf_properties[EXPORT_PDF_NUM_PROPERTIES];

#define TYPE_DRAW_AREA (draw_area_get_type ())
#define DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DRAW_AREA, DrawArea))
#define DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DRAW_AREA, DrawAreaClass))
#define IS_DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DRAW_AREA))
#define IS_DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DRAW_AREA))
#define DRAW_AREA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DRAW_AREA, DrawAreaClass))

typedef struct _DrawArea DrawArea;
typedef struct _DrawAreaClass DrawAreaClass;
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))

struct _ExportPDF {
	GObject parent_instance;
	ExportPDFPrivate * priv;
};

struct _ExportPDFClass {
	GObjectClass parent_class;
};

static gpointer export_pdf_parent_class = NULL;

GType export_pdf_get_type (void) G_GNUC_CONST;
GType draw_area_get_type (void) G_GNUC_CONST;
void export_pdf_export (const gchar* fname,
                        DrawArea* da);
void draw_area_document_rectangle (DrawArea* self,
                                   gdouble* x,
                                   gdouble* y,
                                   gdouble* width,
                                   gdouble* height);
void draw_area_draw_all (DrawArea* self,
                         cairo_t* ctx);
ExportPDF* export_pdf_new (void);
ExportPDF* export_pdf_construct (GType object_type);

void
export_pdf_export (const gchar* fname,
                   DrawArea* da)
{
	gdouble page_width = 0.0;
	gdouble page_height = 0.0;
	gdouble margin = 0.0;
	cairo_surface_t* surface = NULL;
	cairo_surface_t* _tmp0_;
	cairo_t* context = NULL;
	cairo_surface_t* _tmp1_;
	cairo_t* _tmp2_;
	gdouble x = 0.0;
	gdouble y = 0.0;
	gdouble w = 0.0;
	gdouble h = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble width = 0.0;
	gdouble height = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble sf = 0.0;
	cairo_t* _tmp8_;
	cairo_t* _tmp9_;
	GtkStyleContext* _tmp10_;
	cairo_t* _tmp11_;
	cairo_t* _tmp12_;
	cairo_t* _tmp13_;
	g_return_if_fail (fname != NULL);
	g_return_if_fail (da != NULL);
	page_width = 8.5 * 72;
	page_height = (gdouble) (11 * 72);
	margin = 0.5 * 72;
	_tmp0_ = cairo_pdf_surface_create (fname, page_width, page_height);
	surface = _tmp0_;
	_tmp1_ = surface;
	_tmp2_ = cairo_create (_tmp1_);
	context = _tmp2_;
	draw_area_document_rectangle (da, &_tmp3_, &_tmp4_, &_tmp5_, &_tmp6_);
	x = _tmp3_;
	y = _tmp4_;
	w = _tmp5_;
	h = _tmp6_;
	width = (page_width - (2 * margin)) / w;
	height = (page_height - (2 * margin)) / h;
	if (width < height) {
		_tmp7_ = width;
	} else {
		_tmp7_ = height;
	}
	sf = _tmp7_;
	_tmp8_ = context;
	cairo_scale (_tmp8_, sf, sf);
	_tmp9_ = context;
	cairo_translate (_tmp9_, (0 - x) + (margin / sf), (0 - y) + (margin / sf));
	_tmp10_ = gtk_widget_get_style_context ((GtkWidget*) da);
	_tmp11_ = context;
	gtk_render_background (_tmp10_, _tmp11_, x, y, w, h);
	_tmp12_ = context;
	draw_area_draw_all (da, _tmp12_);
	_tmp13_ = context;
	cairo_show_page (_tmp13_);
	_cairo_destroy0 (context);
	_cairo_surface_destroy0 (surface);
}

ExportPDF*
export_pdf_construct (GType object_type)
{
	ExportPDF * self = NULL;
	self = (ExportPDF*) g_object_new (object_type, NULL);
	return self;
}

ExportPDF*
export_pdf_new (void)
{
	return export_pdf_construct (TYPE_EXPORT_PDF);
}

static void
export_pdf_class_init (ExportPDFClass * klass,
                       gpointer klass_data)
{
	export_pdf_parent_class = g_type_class_peek_parent (klass);
}

static void
export_pdf_instance_init (ExportPDF * self,
                          gpointer klass)
{
}

GType
export_pdf_get_type (void)
{
	static volatile gsize export_pdf_type_id__volatile = 0;
	if (g_once_init_enter (&export_pdf_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ExportPDFClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) export_pdf_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ExportPDF), 0, (GInstanceInitFunc) export_pdf_instance_init, NULL };
		GType export_pdf_type_id;
		export_pdf_type_id = g_type_register_static (G_TYPE_OBJECT, "ExportPDF", &g_define_type_info, 0);
		g_once_init_leave (&export_pdf_type_id__volatile, export_pdf_type_id);
	}
	return export_pdf_type_id__volatile;
}

