/* NodeBorderRounded.c generated by valac 0.44.11, the Vala compiler
 * generated from NodeBorderRounded.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <cairo.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>
#include <granite.h>

#define TYPE_NODE_BORDER (node_border_get_type ())
#define NODE_BORDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NODE_BORDER, NodeBorder))
#define IS_NODE_BORDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NODE_BORDER))
#define NODE_BORDER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_NODE_BORDER, NodeBorderIface))

typedef struct _NodeBorder NodeBorder;
typedef struct _NodeBorderIface NodeBorderIface;
typedef enum  {
	NODE_SIDE_LEFT = 1,
	NODE_SIDE_TOP = 2,
	NODE_SIDE_RIGHT = 4,
	NODE_SIDE_BOTTOM = 8
} NodeSide;

#define TYPE_NODE_SIDE (node_side_get_type ())

#define TYPE_NODE_BORDER_ROUNDED (node_border_rounded_get_type ())
#define NODE_BORDER_ROUNDED(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NODE_BORDER_ROUNDED, NodeBorderRounded))
#define NODE_BORDER_ROUNDED_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NODE_BORDER_ROUNDED, NodeBorderRoundedClass))
#define IS_NODE_BORDER_ROUNDED(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NODE_BORDER_ROUNDED))
#define IS_NODE_BORDER_ROUNDED_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NODE_BORDER_ROUNDED))
#define NODE_BORDER_ROUNDED_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NODE_BORDER_ROUNDED, NodeBorderRoundedClass))

typedef struct _NodeBorderRounded NodeBorderRounded;
typedef struct _NodeBorderRoundedClass NodeBorderRoundedClass;
typedef struct _NodeBorderRoundedPrivate NodeBorderRoundedPrivate;
enum  {
	NODE_BORDER_ROUNDED_0_PROPERTY,
	NODE_BORDER_ROUNDED_NUM_PROPERTIES
};
static GParamSpec* node_border_rounded_properties[NODE_BORDER_ROUNDED_NUM_PROPERTIES];

struct _NodeBorderIface {
	GTypeInterface parent_iface;
	gchar* (*name) (NodeBorder* self);
	gchar* (*display_name) (NodeBorder* self);
	gchar* (*icon_name) (NodeBorder* self);
	gboolean (*is_fillable) (NodeBorder* self);
	void (*draw_border) (NodeBorder* self, cairo_t* ctx, gdouble x, gdouble y, gdouble w, gdouble h, NodeSide s);
	void (*draw_fill) (NodeBorder* self, cairo_t* ctx, gdouble x, gdouble y, gdouble w, gdouble h, NodeSide s);
};

struct _NodeBorderRounded {
	GObject parent_instance;
	NodeBorderRoundedPrivate * priv;
};

struct _NodeBorderRoundedClass {
	GObjectClass parent_class;
};

static gpointer node_border_rounded_parent_class = NULL;
static NodeBorderIface * node_border_rounded_node_border_parent_iface = NULL;

GType node_side_get_type (void) G_GNUC_CONST;
GType node_border_get_type (void) G_GNUC_CONST;
GType node_border_rounded_get_type (void) G_GNUC_CONST;
NodeBorderRounded* node_border_rounded_new (void);
NodeBorderRounded* node_border_rounded_construct (GType object_type);
static gchar* node_border_rounded_real_name (NodeBorder* base);
static gchar* node_border_rounded_real_display_name (NodeBorder* base);
static gchar* node_border_rounded_real_icon_name (NodeBorder* base);
static gboolean node_border_rounded_real_is_fillable (NodeBorder* base);
static void node_border_rounded_real_draw_border (NodeBorder* base,
                                           cairo_t* ctx,
                                           gdouble x,
                                           gdouble y,
                                           gdouble w,
                                           gdouble h,
                                           NodeSide s);
static void node_border_rounded_real_draw_fill (NodeBorder* base,
                                         cairo_t* ctx,
                                         gdouble x,
                                         gdouble y,
                                         gdouble w,
                                         gdouble h,
                                         NodeSide s);

NodeBorderRounded*
node_border_rounded_construct (GType object_type)
{
	NodeBorderRounded * self = NULL;
	self = (NodeBorderRounded*) g_object_new (object_type, NULL);
	return self;
}

NodeBorderRounded*
node_border_rounded_new (void)
{
	return node_border_rounded_construct (TYPE_NODE_BORDER_ROUNDED);
}

static gchar*
node_border_rounded_real_name (NodeBorder* base)
{
	NodeBorderRounded * self;
	gchar* _tmp0_;
	gchar* result = NULL;
	self = (NodeBorderRounded*) base;
	_tmp0_ = g_strdup ("rounded");
	result = _tmp0_;
	return result;
}

static gchar*
node_border_rounded_real_display_name (NodeBorder* base)
{
	NodeBorderRounded * self;
	gchar* _tmp0_;
	gchar* result = NULL;
	self = (NodeBorderRounded*) base;
	_tmp0_ = g_strdup (_ ("Rounded Rectangle"));
	result = _tmp0_;
	return result;
}

static gchar*
node_border_rounded_real_icon_name (NodeBorder* base)
{
	NodeBorderRounded * self;
	gchar* _tmp0_;
	gchar* result = NULL;
	self = (NodeBorderRounded*) base;
	_tmp0_ = g_strdup ("minder-node-border-rounded-symbolic");
	result = _tmp0_;
	return result;
}

static gboolean
node_border_rounded_real_is_fillable (NodeBorder* base)
{
	NodeBorderRounded * self;
	gboolean result = FALSE;
	self = (NodeBorderRounded*) base;
	result = TRUE;
	return result;
}

static void
node_border_rounded_real_draw_border (NodeBorder* base,
                                      cairo_t* ctx,
                                      gdouble x,
                                      gdouble y,
                                      gdouble w,
                                      gdouble h,
                                      NodeSide s)
{
	NodeBorderRounded * self;
	self = (NodeBorderRounded*) base;
	g_return_if_fail (ctx != NULL);
	granite_drawing_utilities_cairo_rounded_rectangle (ctx, x, y, w, h, (gdouble) 5);
	cairo_stroke (ctx);
}

static void
node_border_rounded_real_draw_fill (NodeBorder* base,
                                    cairo_t* ctx,
                                    gdouble x,
                                    gdouble y,
                                    gdouble w,
                                    gdouble h,
                                    NodeSide s)
{
	NodeBorderRounded * self;
	self = (NodeBorderRounded*) base;
	g_return_if_fail (ctx != NULL);
	granite_drawing_utilities_cairo_rounded_rectangle (ctx, x, y, w, h, (gdouble) 5);
	cairo_fill (ctx);
}

static void
node_border_rounded_class_init (NodeBorderRoundedClass * klass,
                                gpointer klass_data)
{
	node_border_rounded_parent_class = g_type_class_peek_parent (klass);
}

static void
node_border_rounded_node_border_interface_init (NodeBorderIface * iface,
                                                gpointer iface_data)
{
	node_border_rounded_node_border_parent_iface = g_type_interface_peek_parent (iface);
	iface->name = (gchar* (*) (NodeBorder*)) node_border_rounded_real_name;
	iface->display_name = (gchar* (*) (NodeBorder*)) node_border_rounded_real_display_name;
	iface->icon_name = (gchar* (*) (NodeBorder*)) node_border_rounded_real_icon_name;
	iface->is_fillable = (gboolean (*) (NodeBorder*)) node_border_rounded_real_is_fillable;
	iface->draw_border = (void (*) (NodeBorder*, cairo_t*, gdouble, gdouble, gdouble, gdouble, NodeSide)) node_border_rounded_real_draw_border;
	iface->draw_fill = (void (*) (NodeBorder*, cairo_t*, gdouble, gdouble, gdouble, gdouble, NodeSide)) node_border_rounded_real_draw_fill;
}

static void
node_border_rounded_instance_init (NodeBorderRounded * self,
                                   gpointer klass)
{
}

GType
node_border_rounded_get_type (void)
{
	static volatile gsize node_border_rounded_type_id__volatile = 0;
	if (g_once_init_enter (&node_border_rounded_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NodeBorderRoundedClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) node_border_rounded_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NodeBorderRounded), 0, (GInstanceInitFunc) node_border_rounded_instance_init, NULL };
		static const GInterfaceInfo node_border_info = { (GInterfaceInitFunc) node_border_rounded_node_border_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType node_border_rounded_type_id;
		node_border_rounded_type_id = g_type_register_static (G_TYPE_OBJECT, "NodeBorderRounded", &g_define_type_info, 0);
		g_type_add_interface_static (node_border_rounded_type_id, TYPE_NODE_BORDER, &node_border_info);
		g_once_init_leave (&node_border_rounded_type_id__volatile, node_border_rounded_type_id);
	}
	return node_border_rounded_type_id__volatile;
}

